unit U_TradeGreyClothOutEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, cxSpinEdit,
  StdCtrls, ExtCtrls, cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore,
  dxSkinsDefaultPainters, cxNavigator, dxDateRanges, dxBarBuiltInMenu,
  U_BaseInput, System.ImageList, Vcl.ImgList, dxSkinWXI, dxScrollbarAnnotations;

type
  TfrmTradeGreyClothOutEdit = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1CRType: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    v1Column1: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1CheJian: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId, FStkName, FKHName: string;
  end;

var
  frmTradeGreyClothOutEdit: TfrmTradeGreyClothOutEdit;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_TradeGreyClothStkSel, U_CompanySel;

{$R *.dfm}

procedure TfrmTradeGreyClothOutEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmTradeGreyClothOutEdit.TBAddClick(Sender: TObject);
begin
  try
    frmTradeGreyClothStkSel := TfrmTradeGreyClothStkSel.Create(Application);
    with frmTradeGreyClothStkSel do
    begin
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        frmTradeGreyClothStkSel.CDS_Main.DisableControls;
        with frmTradeGreyClothStkSel.CDS_Main do
        begin
          First;
          while frmTradeGreyClothStkSel.CDS_Main.Locate('SSel', True, []) do
          begin
            with Self.CDS_Sub do
            begin
              Append;
              FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
              FieldByName('STKID').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('BCIOID').Value;
              FieldByName('IOType').Value := '加工出库';
              FieldByName('FromCoNo').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('FromCoNo').Value;
              FieldByName('FromCoName').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('FromCoName').Value;
              FieldByName('StkCoNo').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('StkCoName').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;
              FieldByName('ToCoNo').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('ToCoName').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;
              FieldByName('C_Name').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_Name').Value;
              FieldByName('C_Spec').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_Spec').Value;
              FieldByName('QtyUnit').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('QtyUnit').Value;
              FieldByName('Qty').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('STKQTY').Value;
              FieldByName('Piece').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('StkPiece').Value;
              FieldByName('BatchNo').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('BatchNo').Value;
              FieldByName('C_Width').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_Width').Value;
              FieldByName('C_GramWeight').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_GramWeight').Value;
              FieldByName('FromOrdNo').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('FromOrdNo').Value;
              FieldByName('Workshop').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('Workshop').Value;
              FieldByName('PieceWeight').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('PieceWeight').Value;
              FieldByName('C_ColorDepth').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_ColorDepth').Value;
              FieldByName('C_Color').Value := frmTradeGreyClothStkSel.CDS_Main.fieldbyname('C_Color').Value;

            end;
            frmTradeGreyClothStkSel.CDS_Main.Delete;
          end;
        end;
        frmTradeGreyClothStkSel.CDS_Main.EnableControls;
      end;
    end;
  finally
    frmTradeGreyClothStkSel.Free;
  end;

end;

function TfrmTradeGreyClothOutEdit.SaveCKData(): Boolean;
var
  MBCIOID, Maxno: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
          Open;
        end;
        MBCIOID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
        if Trim(MBCIOID) = '' then
        begin
          if not GetLSNo(ADOQueryCmd, Maxno, 'PC', 'BS_Cloth_IO', 3, 1) then
            raise Exception.Create('取染色坯布出库编号失败！');
        end
        else
        begin
          Maxno := Trim(MBCIOID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MBCIOID) = '' then
          begin
            Append;
            FieldByName('Filler').Value := Trim(DName)
          end
          else
          begin
            Edit;
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'BS_Cloth_IO', 2);
          FieldByName('STKName').Value := FSTKName;
          FieldByName('BCIOID').Value := Trim(Maxno);
          FieldByName('IOFlag').Value := '出库';
          FieldByName('IOQtyFlag').Value := -1;
          FieldByName('STKID').Value := CDS_Sub.fieldbyname('STKID').Value;
          FieldByName('FromCoNo').Value := CDS_Sub.fieldbyname('FromCoNo').Value;
          FieldByName('FromCoName').Value := CDS_Sub.fieldbyname('FromCoName').Value;
          FieldByName('StkCoNo').Value := CDS_Sub.fieldbyname('StkCoNo').Value;
          FieldByName('ToCoNo').Value := CDS_Sub.fieldbyname('ToCoNo').Value;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update BS_Cloth_IO Set StkPiece=(select Sum(isnull(Piece,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID)');
          sql.Add(',STKQty=(select Sum(isnull(Qty,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID )');
          sql.Add('where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('STKQty').Value < 0 then
          raise Exception.Create('出库数量大于入库数量不能保存！');

        if ADOQueryTemp.FieldByName('StkPiece').Value < 0 then
          raise Exception.Create('出库匹数大于入库匹数不能保存！');

        with ADOQueryCmd do
        begin
          Close;
          Sql.Clear;
          Sql.Add('exec P_BS_Cloth_Move ');
          Sql.Add(' @BCIOID=' + quotedstr(Trim(Maxno)));
          Open;
        end;
        if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
          raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
        Edit;
        FieldByName('BCIOID').Value := Trim(Maxno);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmTradeGreyClothOutEdit.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmTradeGreyClothOutEdit.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(FSTKName + '出库登记', Tv1, '贸易汇总仓库');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from BS_Cloth_IO A');
    sql.Add(' where BCIOID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
//  fsj:='select name=CJName ,Code=null from CheJian';
//  SInitCxGridComboBoxBySql(ADOQueryTemp,v1CheJian,fsj,0,True,'');
end;

procedure TfrmTradeGreyClothOutEdit.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;

    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        Sql.Clear;
        Sql.Add('exec P_BS_Cloth_Out_Del ');
        Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
        Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
        Sql.Add(',@DName=' + quotedstr(Trim(DName)));
        Open;
      end;
      if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
        raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    end;
  end
  else
    CDS_Sub.Delete;
end;

procedure TfrmTradeGreyClothOutEdit.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('IOTime', null, []) = True then
  begin
    Application.MessageBox('出库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('IOType', null, []) = True then
  begin
    Application.MessageBox('出库类型不能为空!', '提示', 0);
    Exit;
  end;
 { if CDS_Sub.Locate('CRType;LCKNO', VarArrayOf(['加工出库', Null]), [loPartialKey]) then
  begin
    Application.MessageBox('加工出库的数据流程卡号不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('Piece', null, []) = True then
  begin
    Application.MessageBox('匹数不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmTradeGreyClothOutEdit.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(fSTKName + '出库登记', Tv1, '贸易汇总仓库');

end;

procedure TfrmTradeGreyClothOutEdit.Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '供应商';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ToCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('ToCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmTradeGreyClothOutEdit.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FFSPID: string;
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
      Open;
    end;
    FFSPID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
    if Trim(FFSPID) <> '' then
    begin
      v1CRType.Options.Editing := False;
    end
    else
    begin
      v1CRType.Options.Editing := True;
    end;
  end
  else
  begin
    v1CRType.Options.Editing := True;
  end;
end;

end.

